Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class ComputedElement

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.ParentNodeConstructor
                  net.sf.saxon.instruct.ElementCreator
                      net.sf.saxon.instruct.ComputedElement

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator, TailCallReturner

public class ComputedElement
extends ElementCreator

An instruction representing an xsl:element element in an XSLT stylesheet, or a computed element constructor in XQuery. (In both cases, if the element name is expressed as a compile-time expression, then a FixedElement instruction is used instead.)

See Also:
  `FixedElement`, Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.instruct.ElementCreator
`inheritNamespaces`

Fields inherited from class net.sf.saxon.instruct.ParentNodeConstructor
`content`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ComputedElement(Expression elementName, Expression namespace, NamespaceResolver nsContext, SchemaType schemaType, int validation, boolean inheritNamespaces, boolean allowQName)` Create an instruction that creates a new element node

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Display this instruction as an expression, for diagnostics
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the value returned by this instruction
`int` | `getNameCode(XPathContext context)` Callback from the superclass ElementCreator to get the nameCode for the element name
`java.util.Iterator` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`protected void` | `outputNamespaceNodes(XPathContext context, Receiver out)` Callback to output namespace nodes for the new element.
`protected void` | `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
`Expression` | `simplify(StaticContext env)` Simplify an expression.
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.instruct.ElementCreator
`computeSpecialProperties, evaluateItem, getActiveNamespaces, getImplementationMethod, getValidationMode, processLeavingTail, setValidationMode, suppressValidation`

Methods inherited from class net.sf.saxon.instruct.ParentNodeConstructor
`createsNewNodes, getCardinality, getContentExpression, getSchemaType, getValidationAction, isLazyConstruction, isNamespaceSensitive, optimize, setContentExpression, setLazyConstruction, setSchemaType`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, dynamicError, evaluateAsString, getInstructionInfo, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, getColumnNumber, getConstructType, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### ComputedElement

    public ComputedElement(Expression elementName,
                           Expression namespace,
                           NamespaceResolver nsContext,
                           SchemaType schemaType,
                           int validation,
                           boolean inheritNamespaces,
                           boolean allowQName)

  Create an instruction that creates a new element node

Parameters:
  `elementName` - Expression that evaluates to produce the name of the element node as a lexical QName
  `namespace` - Expression that evaluates to produce the namespace URI of the element node. Set to null if the namespace is to be deduced from the prefix of the elementName.
  `nsContext` - Saved copy of the static namespace context for the instruction. Can be set to null if namespace is supplied.
  `schemaType` - The required schema type for the content
  `allowQName` -

Method Detail

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Description copied from class: `ParentNodeConstructor`
  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Description copied from interface: `Expression`
  Perform type checking of an expression and its subexpressions.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  Specified by:
    `typeCheck` in interface `Expression`
  Overrides:
    `typeCheck` in class `ParentNodeConstructor`
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the value returned by this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` -
  Returns:
    the item type

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Description copied from class: `ParentNodeConstructor`
  Get the immediate sub-expressions of this expression.

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `ParentNodeConstructor`
  Returns:
    an iterator containing the sub-expressions of this expression

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Overrides:
    `promoteInst` in class `ParentNodeConstructor`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Specified by:
    `checkPermittedContents` in interface `Expression`
  Overrides:
    `checkPermittedContents` in class `ComputedExpression`
  Throws:
    `XPathException`

### getNameCode

    public int getNameCode(XPathContext context)
                    throws XPathException,
                           XPathException

  Callback from the superclass ElementCreator to get the nameCode for the element name

  Specified by:
    `getNameCode` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
  Returns:
    the name code for the element name
  Throws:
    `XPathException`

### outputNamespaceNodes

    protected void outputNamespaceNodes(XPathContext context,
                                        Receiver out)
                                 throws XPathException

  Callback to output namespace nodes for the new element.

  Specified by:
    `outputNamespaceNodes` in class `ElementCreator`
  Parameters:
    `context` - The execution context
    `out` - the Receiver where the namespace nodes are to be written
  Throws:
    `XPathException`

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Display this instruction as an expression, for diagnostics

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD